<?

class get_data {	// general class that can collect data from backend or other resources
	function gdata($data, $r="",$c="") {
	
		if($data['method'] == 'txt') {			// text
			$o = $data['value'];
		} else if ($data['method'] == 'variable'){	// Variable
			$o = $data['value'];
		} else if ($data['method'] == 'action'){	// Action
			$o = exec($data['value']);
		} else {					// Unknown method
			$o = '<b><u>unknown stuff</u></b>';
		}
		
		return $o;
	}
}

class form_junk extends get_data {
	
	function form_junk() {
		mt_srand((double)microtime()*1000000);
		$this->junk = array ('vi', 'nel', 'mon', 'pu', 'it', 'ca', 'co', 'er', 'ba', 'ca', 'da', 'ma', 'mo', 'zu', 'bu', 'ru', 'vu', 'ette', ' ', ':', '...');
		$this->numsyl = sizeof($this->junk);
	}
	
	function make() {
		$num_syl = mt_rand(2,10); // number of syllabs
		
		for ($i = 0; $i < $num_syl; $i++) {
			$id = mt_rand(0,$this->numsyl);
			$out .= $this->junk[$id];
		}
		
		$this->html = $out;
		return true;
	}
}

class form_list extends get_data {
	
	function make() {
		foreach($this->raw as $l) {
			$h = $this->gdata($l);
			$j = explode(',', $h);
			foreach($j as $k) {
				$html[] = '<option>'.$k;
			}
		}
		$pre = '<select name="'.$this->val.'">';
		$post = '</select>';
		$this->html = $pre.implode("\n",$html).$post;
	}
}

class form_field extends get_data {
	
	function make() {
		foreach($this->raw as $l) {
			$html[] = $this->gdata($l);
		}
		$pre = '<input type="text" name="'.$this->val.'" value="';
		$post = '">';
		$this->html = $pre.implode('',$html).$post;
	}
}

class form_checkbox extends get_data {
	
	function make() {
		foreach($this->raw as $l) {
			$h = $this->gdata($l);
			$j = explode(',', $h);
			foreach($j as $k) {
				$html[] = '<input type="checkbox" name="'.$this->val.'" value="'.$k.'"> '.$k.'<br>';
			}
		}
		$this->html = implode("\n",$html);
	}
}

class form_radio extends get_data {
	
	function make() {
		foreach($this->raw as $l) {
			$h = $this->gdata($l);
			$j = explode(',', $h);
			foreach($j as $k) {
				$html[] = '<input type="radio" name="'.$this->val.'" value="'.$k.'"> '.$k.'<br>';
			}
		}
		$this->html = implode("\n",$html);
	}
}

class data_struct extends get_data { // data structure containing ALL the data to display

	function make() {			// makes a good looking table for the table class
		if (!$this->raw) {
			return false;
		}
		
		$r = 0;	// row
		$c = 0;	// column
				
		foreach($this->raw as $line) {
			foreach($line as $cell) {
				foreach($cell['access'] as $udata) {
					 $part[$r][$c][] = $this->gdata($udata, $r,$c);
				}
				$this->data[$r][$c] = implode($cell['separator'], $part[$r][$c]);
				$c ++; 	// change col
			}
			$r ++; 	// change row
		}
	}
}

?>
